'NK DS Clock Anode @ 22.12.92 [2014]
'By Behnam Zakizadeh for NovinKit.com
'Comm Anode 7 segment.
$prog &HC0 , &HA3 , &HD9 , &H00
'Set fuse bit on Internal RC 4MHz , Enable BODEN, Set BODLEVEL on 2.7 Volt
'$regfile = "m8def.dat"
$regfile = "m8adef.dat"
$crystal = 4000000
$hwstack = 64
$swstack = 64
$framesize = 64
$lib "ds1307clock.lib"

Config Watchdog = 2048
Start Watchdog
Reset Watchdog

'I/O
'Come Anodes 1 2 3 4
Config Pind.0 = Output                                      '1000
Config Pind.6 = Output                                      '0200
Config Pind.7 = Output                                      '0030
Config Pind.5 = Output                                      '0004

'Segments a b c d e f g
Config Pind.1 = Output                                      'a
Config Pinb.0 = Output                                      'b
Config Pinb.2 = Output                                      'c
Config Pinb.4 = Output                                      'd
Config Pinb.5 = Output                                      'e
Config Pind.2 = Output                                      'f
Config Pinb.1 = Output                                      'g

'Second Blinking
Config Pinb.3 = Output                                      'With3,4 (0034)
Config Pind.3 = Input                                       'Hour Key
Config Pind.4 = Input                                       'Minute Key
Ddrb.6 = 0                                                  'On_key
Ddrb.7 = 0                                                  'off_key
Ddrc.3 = 1                                                  'rly

'Set Pullup Resistor For Setting Key's
Set Portd.3
Set Portd.4
Portb.6 = 1
Portb.7 = 1
Portc.3 = 0

'Aliases
'Dataport Alias Portd
'Comm Alias Portc
Hour_key Alias Pind.3
Min_key Alias Pind.4
Bk_sec Alias Portb.3
On_key Alias Pinb.6
Off_key Alias Pinb.7
Relay Alias Portc.3

Seg_a Alias Portd.1
Seg_b Alias Portb.0
Seg_c Alias Portb.2
Seg_d Alias Portb.4
Seg_e Alias Portb.5
Seg_f Alias Portd.2
Seg_g Alias Portb.1

Comm_1 Alias Portd.0
Comm_2 Alias Portd.6
Comm_3 Alias Portd.7
Comm_4 Alias Portd.5



Config Sda = Portc.5
Config Scl = Portc.4

'address of ds1307
Const Ds1307w = &HD0                                        'Addresses of Ds1307 clock
Const Ds1307r = &HD1

Config Clock = User

Reset Watchdog

'dim other needed variables
Dim Weekday As Byte


'Variables
Dim A As Byte , Dp As Bit
Dim Tmp As Byte
Dim On_hour As Byte , On_min As Byte
Dim Off_hour As Byte , Off_min As Byte

Dim On_time As Word , Off_time As Word , Now_time As Word

Dim On_hour_save As Eram Byte , On_min_save As Eram Byte
Dim Off_hour_save As Eram Byte , Off_min_save As Eram Byte

Dim B1 As Bit , B2 As Bit


'Declaration
Declare Sub Refresh
Declare Sub Send
Declare Sub Blink_sec
Declare Sub Rst7
Declare Sub Rst


'for test all system
If Hour_key = 0 And Min_key = 1 Then
   Reset Watchdog

   Set Comm_1
   Set Comm_2
   Set Comm_3
   Set Comm_4

   Reset Seg_a
   Reset Seg_b
   Reset Seg_c
   Reset Seg_d
   Reset Seg_e
   Reset Seg_f
   Reset Seg_g
   Reset Bk_sec

   Waitms 500 : Reset Watchdog
   Set Relay


   Waitms 500 : Reset Watchdog
   Waitms 500 : Reset Watchdog
   Waitms 500 : Reset Watchdog
   Waitms 500 : Reset Watchdog

   Reset Relay
   Call Rst
   Call Rst7


End If


'Reset Default
If Hour_key = 0 And Min_key = 0 Then
   Reset Watchdog
   On_hour_save = 1 : Waitms 10
   On_min_save = 0 : Waitms 10
   Off_hour_save = 2 : Waitms 10
   Off_min_save = 0 : Waitms 10

   Time$ = "12:00:00"                                       ' to watch the day changing value
   Date$ = "06-03-13"

   Reset Watchdog

   Comm_1 = 1
   Comm_2 = 1
   Comm_3 = 1
   Comm_4 = 1

   Seg_a = 0
   Seg_b = 1
   Seg_c = 1
   Seg_d = 1
   Seg_e = 1
   Seg_f = 1
   Seg_g = 1
   Bk_sec = 1



   While Hour_key = 0
      Reset Watchdog
   Wend
   Wait 1
   Reset Watchdog
End If

'loading
On_hour = On_hour_save : Waitms 10
On_min = On_min_save : Waitms 10
Off_hour = Off_hour_save : Waitms 10
Off_min = Off_min_save : Waitms 10

'Timer
Config Timer1 = Timer , Prescale = 64
Enable Interrupts
Enable Timer1
'3036
Timer1 = 3017
Start Timer1
On Ovf1 Ov1


'Main Prog Start Here:
Do
   Call Send
   Reset Watchdog
   '********** Key ***********

   If Hour_key = 0 Then
      Reset Watchdog
      If On_key = 1 And Off_key = 1 Then
         Reset Watchdog
         Incr _hour
         If _hour > 23 Then _hour = 0
         Gosub Settime
         For Tmp = 1 To 20
            Call Send
            Reset Watchdog
         Next Tmp
      End If

      If On_key = 0 And Off_key = 1 Then
         Reset Watchdog
         Incr On_hour
         If On_hour > 23 Then On_hour = 0
         On_hour_save = On_hour : Waitms 10
         For Tmp = 1 To 20
            Call Send
            Reset Watchdog
         Next Tmp
      End If

      If On_key = 1 And Off_key = 0 Then
         Reset Watchdog
         Incr Off_hour
         If Off_hour > 23 Then Off_hour = 0
         Off_hour_save = Off_hour : Waitms 10
         For Tmp = 1 To 20
            Call Send
            Reset Watchdog
         Next Tmp
      End If

   End If

   If Min_key = 0 Then
      Reset Watchdog
      If On_key = 1 And Off_key = 1 Then
         Incr _min
         If _min > 59 Then _min = 0
         Gosub Settime
         For Tmp = 1 To 20
            Call Send
            Reset Watchdog
         Next Tmp
      End If

      If On_key = 0 And Off_key = 1 Then
         Reset Watchdog
         Incr On_min
         If On_min > 59 Then On_min = 0
         On_min_save = On_min : Waitms 10
         For Tmp = 1 To 20
            Call Send
            Reset Watchdog
         Next Tmp
      End If

      If On_key = 1 And Off_key = 0 Then
         Reset Watchdog
         Incr Off_min
         If Off_min > 59 Then Off_min = 0
         Off_min_save = Off_min : Waitms 10
         For Tmp = 1 To 20
            Call Send
            Reset Watchdog
         Next Tmp
      End If

   End If
   Reset Watchdog

Loop
End



Sub Refresh
Call Rst7
Select Case A
Case 0:
   Seg_a = 0
   Seg_b = 0
   Seg_c = 0
   Seg_d = 0
   Seg_e = 0
   Seg_f = 0
   'Seg_g = 1
Case 1:
   'Seg_a = 1
   Seg_b = 0
   Seg_c = 0
   'Seg_d = 1
   'Seg_e = 1
   'Seg_f = 1
   'Seg_g = 1
Case 2:
   Seg_a = 0
   Seg_b = 0
   'Seg_c = 1
   Seg_d = 0
   Seg_e = 0
   'Seg_f = 1
   Seg_g = 0
Case 3:
   Seg_a = 0
   Seg_b = 0
   Seg_c = 0
   Seg_d = 0
   'Seg_e = 1
   'Seg_f = 1
   Seg_g = 0
Case 4:
   'Seg_a = 1
   Seg_b = 0
   Seg_c = 0
   'Seg_d = 1
   'Seg_e = 1
   Seg_f = 0
   Seg_g = 0
Case 5:
   Seg_a = 0
   'Seg_b = 1
   Seg_c = 0
   Seg_d = 0
   'Seg_e = 1
   Seg_f = 0
   Seg_g = 0
Case 6:
   Seg_a = 0
   'Seg_b = 1
   Seg_c = 0
   Seg_d = 0
   Seg_e = 0
   Seg_f = 0
   Seg_g = 0
Case 7:
   Seg_a = 0
   Seg_b = 0
   Seg_c = 0
   'Seg_d = 1
   'Seg_e = 1
   'Seg_f = 1
   'Seg_g = 1
Case 8:
   Seg_a = 0
   Seg_b = 0
   Seg_c = 0
   Seg_d = 0
   Seg_e = 0
   Seg_f = 0
   Seg_g = 0
Case 9:
   Seg_a = 0
   Seg_b = 0
   Seg_c = 0
   Seg_d = 0
   'Seg_e = 1
   Seg_f = 0
   Seg_g = 0
'Case Else : Goto Main
End Select
   If Dp = 1 Then
      If Timer1 > 0 And Timer1 < 31260 Then Bk_sec = 0
      'Bk_sec = S
    Else
      Bk_sec = 1
   End If


   '========================= relay control ========================
   Now_time = _hour * 100
   Now_time = Now_time + _min

   On_time = On_hour * 100
   On_time = On_time + On_min

   Off_time = Off_hour * 100
   Off_time = Off_time + Off_min

   If On_time > Off_time Then

     If Now_time >= On_time And Now_time <= 2359 Then
        B1 = 1
     Else
        B1 = 0
     End If

     If Now_time >= 0 And Now_time < Off_time Then
        B2 = 1
     Else
        B2 = 0
     End If

     If B1 = 1 Or B2 = 1 Then
        Relay = 1
     Else
        Relay = 0
     End If

   End If

   If On_time < Off_time Then
      If Now_time >= On_time And Now_time < Off_time Then
        Relay = 1
     Else
        Relay = 0
     End If
   End If

Waitms 4
Call Rst7                                                   'Clear Screen
End Sub


Sub Rst
   Reset Comm_1
   Reset Comm_2
   Reset Comm_3
   Reset Comm_4
End Sub

Sub Rst7
   Set Seg_a
   Set Seg_b
   Set Seg_c
   Set Seg_d
   Set Seg_e
   Set Seg_f
   Set Seg_g
   Set Bk_sec
End Sub

Sub Send
   If On_key = 1 And Off_key = 1 Then
      Gosub Getdatetime
      Call Rst : Set Comm_1 : Dp = 0 : A = _hour \ 10 : Call Refresh
      Call Rst : Set Comm_2 : Dp = 1 : A = _hour Mod 10 : Call Refresh
      Call Rst : Set Comm_3 : Dp = 0 : A = _min \ 10 : Call Refresh
      Call Rst : Set Comm_4 : Dp = 0 : A = _min Mod 10 : Call Refresh
   End If
   If On_key = 0 And Off_key = 1 Then
      Call Rst : Set Comm_1 : Dp = 0 : A = On_hour \ 10 : Call Refresh
      Call Rst : Set Comm_2 : Dp = 1 : A = On_hour Mod 10 : Call Refresh
      Call Rst : Set Comm_3 : Dp = 0 : A = On_min \ 10 : Call Refresh
      Call Rst : Set Comm_4 : Dp = 0 : A = On_min Mod 10 : Call Refresh
   End If
   If On_key = 1 And Off_key = 0 Then
      Call Rst : Set Comm_1 : Dp = 0 : A = Off_hour \ 10 : Call Refresh
      Call Rst : Set Comm_2 : Dp = 1 : A = Off_hour Mod 10 : Call Refresh
      Call Rst : Set Comm_3 : Dp = 0 : A = Off_min \ 10 : Call Refresh
      Call Rst : Set Comm_4 : Dp = 0 : A = Off_min Mod 10 : Call Refresh
   End If





End Sub

Ov1:
Timer1 = 3017
Reset Watchdog
Return

'called from ds1307clock.lib
Getdatetime:
  I2cstart                                                  ' Generate start code
  I2cwbyte Ds1307w                                          ' send address
  I2cwbyte 0                                                ' start address in 1307

  I2cstart                                                  ' Generate start code
  I2cwbyte Ds1307r                                          ' send address
  I2crbyte _sec , Ack
  I2crbyte _min , Ack                                       ' MINUTES
  I2crbyte _hour , Ack                                      ' Hours
  I2crbyte Weekday , Ack                                    ' Day of Week
  I2crbyte _day , Ack                                       ' Day of Month
  I2crbyte _month , Ack                                     ' Month of Year
  I2crbyte _year , Nack                                     ' Year
  I2cstop
  _sec = Makedec(_sec) : _min = Makedec(_min) : _hour = Makedec(_hour)
  _day = Makedec(_day) : _month = Makedec(_month) : _year = Makedec(_year)
Return

Setdate:
  _day = Makebcd(_day) : _month = Makebcd(_month) : _year = Makebcd(_year)
  I2cstart                                                  ' Generate start code
  I2cwbyte Ds1307w                                          ' send address
  I2cwbyte 4                                                ' starting address in 1307
  I2cwbyte _day                                             ' Send Data to SECONDS
  I2cwbyte _month                                           ' MINUTES
  I2cwbyte _year                                            ' Hours
  I2cstop
Return

Settime:
  _sec = Makebcd(_sec) : _min = Makebcd(_min) : _hour = Makebcd(_hour)
  I2cstart                                                  ' Generate start code
  I2cwbyte Ds1307w                                          ' send address
  I2cwbyte 0                                                ' starting address in 1307
  I2cwbyte _sec                                             ' Send Data to SECONDS
  I2cwbyte _min                                             ' MINUTES
  I2cwbyte _hour                                            ' Hours
  I2cstop
Return
'_______________________________________________________________________________